# Copyright 2020 Benedict Suska <benedict.suska@teckids.org>
# Copytight 2020 Nikolas Scheer <gundhie31@gmail.com>
# Copyright 2020 Jonah Döll <jonah.doell@teckids.org>
# Copyright 2020 Dominik George <dominik.george@teckids.org>
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

import machine
import network

from mytrix import Matrix

from credentials import *


def connect_wifi(ssid, psk):
    wlan = network.WLAN(network.STA_IF)
    wlan.active(True)
    wlan.connect(ssid, psk)
    while not wlan.isconnected():
        pass


connect_wifi(SSID, PSK)

matrix = Matrix(HOMESERVER, MATRIX_ID, ACCESS_TOKEN)
matrix.send_room_message(ROOM_ID, "Hi! Ready to receive commands. Try !on and !off.")

led = machine.Pin(5, machine.Pin.OUT)
button = machine.Pin(4, machine.Pin.IN)

btn_status = False
cases = {"!on": led.on, "!off": led.off}
while True:
    matrix.react_room_messages(ROOM_ID, cases)

    if btn_status != button.value():
        matrix.send_message(ROOM_ID, "!on" if button.value() else "!off")
        btn_status = button.value()
